/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.sf.jguard.jee.extras.dwr2;

import java.lang.reflect.Method;
import java.security.AccessControlException;
import java.security.Permission;
import java.security.PrivilegedActionException;
import java.util.logging.Logger;
import javax.servlet.http.HttpServletRequest;
import net.sf.jguard.jee.authorization.http.HttpAccessControllerUtils;
import org.directwebremoting.impl.DefaultAccessControl;
import org.directwebremoting.extend.Creator;
import uk.ltd.getahead.dwr.WebContextFactory;

/**
 * link DWR with jguard to unify access control in jguard.
 * this implementation works in DWR 2.x.
 * @author <a href="mailto:diabolo512@users.sourceforge.net">Charles Gay</a>
 */
public class DWR2AccessControl extends DefaultAccessControl{
        private static final Logger logger = Logger.getLogger(DWR2AccessControl.class.getName());
        
	public DWR2AccessControl(){
		super();
	}
	

	public void  assertExecutionIsPossible(Creator creator, String className, Method method) {
            //TODO implements DWR1Authorizationbindings, DWR1AuthenticationBindings and 
            //DWR2Authorizationbindings, DWR2AuthenticationBindings
            //http://fisheye5.cenqua.com/browse/dwr/java/org/directwebremoting/impl/DefaultAccessControl.java?r=1.15
            StringBuffer actions = new StringBuffer();
            actions.append(creator.getClass().getName());
            actions.append(",");
            actions.append(creator.getType().getName());
            actions.append(",");
            actions.append(method.getName());
            Permission p = new DWR2Permission("dummy name created by DWR2AccessControl to check access  ", actions.toString());
            HttpServletRequest req = WebContextFactory.get().getHttpServletRequest();
            try {
                HttpAccessControllerUtils.checkPermission(req.getSession(true), p);
            } catch (AccessControlException ex) {
                throw new SecurityException(ex);
            } catch (PrivilegedActionException ex) {
                throw new SecurityException(ex);
            }
	}

	
	
	public void addRoleRestriction(String scriptName, String methodName, String role){
		super.addRoleRestriction(scriptName,methodName,role);
	}
	
	public void addIncludeRule(String scriptName, String methodName){
		super.addIncludeRule(scriptName, methodName);
	}
	
	public void addExcludeRule(String scriptName, String methodName){
		super.addExcludeRule(scriptName, methodName);
	}

}
