/*
jGuard is a security framework based on top of jaas (java authentication and authorization security).
it is written for web applications, to resolve simply, access control problems.
version $Name$
http://sourceforge.net/projects/jguard/

Copyright (C) 2004  Charles GAY

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


jGuard project home page:
http://sourceforge.net/projects/jguard/

*/

/**
 * 
 * @author <a href="mailto:diabolo512@users.sourceforge.net">Charles Gay</a>
 */
package net.sf.jguard.jsf.authorization;

import java.security.Permission;

import javax.faces.application.FacesMessage;
import javax.faces.application.NavigationHandler;
import javax.faces.component.UIViewRoot;
import javax.faces.context.FacesContext;

import net.sf.jguard.core.CoreConstants;
import net.sf.jguard.core.authentication.AccessContext;
import net.sf.jguard.core.authorization.AuthorizationBindings;
import net.sf.jguard.jsf.ExternalContextUtil;
import net.sf.jguard.jsf.permissions.JSFPermission;

public class JSFAuthorizationBindings implements AuthorizationBindings{

	public void accessDenied(AccessContext context) {
		FacesContext facesContext =  FacesContext.getCurrentInstance();
		String outcomeAccessDenied = "accessDenied";
		NavigationHandler nh = facesContext.getApplication().getNavigationHandler();
		nh.handleNavigation(facesContext, null, outcomeAccessDenied);
		facesContext.addMessage("accessDenied", new FacesMessage(FacesMessage.SEVERITY_WARN,"access denied","access to this resource is denied"));
	}

	public void authorize(AccessContext context) {
		// TODO Auto-generated method stub
		
	}

	public Permission getPermissionRequested(AccessContext context) {
                UIViewRoot viewRoot = FacesContext.getCurrentInstance().getViewRoot();
                if(viewRoot==null){
                    throw new RuntimeException(" UIviewRoot is null ");
                }
                String viewId = viewRoot.getViewId();
		JSFPermission jsfPermission = new JSFPermission(viewId);
		return jsfPermission;
	}

	public void setLastAccessDeniedPermission(AccessContext context,
			Permission permission) {
		FacesContext facesContext =  FacesContext.getCurrentInstance();
		ExternalContextUtil.setAttribute(facesContext.getExternalContext(),CoreConstants.LAST_ACCESS_DENIED_PERMISSION,permission);
	}

}
